实例讲解PHP异常PHP异常的概念内置异常类异常可以冒泡传递自定义异常类自定义异常处理器像处理异常一样处理错误

PHP异常的概念

PHP中的异常与错误是两个不同的概念,异常是指程序运行与预期不一致,需要由开发人员手动抛出。

error_reporting(-1);
$num = NULL;
try {
    $num = 3/0;
} catch (Exception $e) {
    echo $e->getMessage();
}

程序报Warning: Division by zero错误,而不是异常

要想程序抛出异常,需要由开发人员手动抛出:

error_reporting(-1);
$num = NULL;
try {
    $num1 = 3;
    $num2 = 0;
    if ($num2 == 0) {
        throw new Exception("0不能作为除数"); // 手动抛出异常
    }
} catch (Exception $e) { // 捕获异常
    echo $e->getMessage();
}

PHP

内置异常类

PHP有一些内置的异常类,能够自动捕获异常

header('content-type:text/html;charset=utf-8');
try {
    $pdo = new Pdo("mysql:host=localhost;dbname=mysql", 'root', 'nothing'); // 密码随便填,故意写错
    // 并没有手动抛异常
    var_dump($pdo);
} catch (PDOException $e) {
    echo $e->getMessage() . "<br />";
}

echo "测试内置的异常类";

结果如下:

SQLSTATE[HY000] [1045] Access denied for user 'root'@'localhost' (using password: YES)
测试内置的异常类

异常可以冒泡传递

错误一经出现就要马上处理,而异常是可以冒泡传递的。因此异常可以嵌套。如果所在层的异常抛出后没有被本层捕获,就会寻找上层的捕获程序

多层异常嵌套

header('content-type:text/html;charset=utf-8');
try {
    try {
        throw new Exception('测试异常1');
    } catch (Exception $e) {
        echo $e->getMessage() . "--第二层<br />";
        try {
            throw new Exception('测试异常2');
        } catch (Exception $e) {
            echo $e->getMessage() . "--第三层<br />";
        }
    }
} catch (Exception $e) {
    echo $e->getMessage() . "--第一层<br />";
}

结果:

测试异常1--第二层
测试异常2--第三层

异常冒泡传递

header('content-type:text/html;charset=utf-8');
try {
    try {
        throw new Exception('测试异常1');
    } catch (Exception $e) {
        echo $e->getMessage() . "--第二层<br />";
        throw new Exception('测试异常2'); // 当前层并没有catch捕获此异常,因此会到外层去寻找捕获
    }
} catch (Exception $e) {
    echo $e->getMessage() . "--第一层<br />";
}
测试异常1--第二层
测试异常2--第一层

自定义异常类

自定义的异常类需要继承Exception,可以重写父类的两个方法:__construct__toString

class MyException extends Exception
{
    public function __construct($message = "", $code = 0, Throwable $previous = null)
    {
        parent::__construct($message, $code, $previous);
    }

    public function __toString()
    {
        $message = "哈哈,出现异常了,是不是又写了一天的bug啊<br />";
        $message .= $this->message;
        return $message;
    }

    /**
     * 自定义的方法
     */
    public function test()
    {
        echo "异常的测试方法<br />";
    }
}

try {
    throw new MyException('这是自定义的异常');
} catch (MyException $e) {
    echo $e;
    echo $e->getMessage();
    $e->test();
}

结果:

哈哈,出现异常了,是不是又写了一天的bug啊
这是自定义的异常这是自定义的异常异常的测试方法

还可以分类捕获异常:

$type = 1;

try {
    if ($type == 1) {
        throw new Exception('系统异常');
    } else {
        throw new MyException('这是自定义的异常');
    }
} catch (MyException $e) {
    echo $e;
    echo $e->getMessage();
    $e->test();
} catch (Exception $e) {
    echo $e->getMessage();
}

分类捕获异常时,系统异常基类要放到最后,不然会拦截到自定义的异常

自定义异常处理器

使用set_exception_handler函数可指定函数接管异常处理,restore_exception_handler函数能恢复到上一次定义过的异常处理函数

header('content-type:text/html;charset=utf-8');
function exceptionHandler_1($e)
{
    echo $e->getMessage() . "<br />";
    echo "我来接!自定义的异常处理器1--" . __FUNCTION__ . "<br />";
}

function exceptionHandler_2($e)
{
    echo $e->getMessage() . "<br />";
    echo "放着我来!自定义的异常处理器2--" . __FUNCTION__ . "<br />";
}

set_exception_handler('exceptionHandler_1');
set_exception_handler('exceptionHandler_2');

// 恢复到上一次定义过的异常处理函数
restore_exception_handler();
throw new Exception("异常信息,哪个处理器来接?");

// 抛出异常后,程序随即中止
echo "程序不会继续往下跑...<br />";

结果:

异常信息,哪个处理器来接?
我来接!自定义的异常处理器1--exceptionHandler_1

像处理异常一样处理错误

通过set_error_handler函数,我们可以捕获错误,像处理异常一样。

header('content-type:text/html;charset=utf-8');

function exception_error_handle($errno, $errstr, $errfile, $errline)
{
    throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}

// 不开启错误处理的情况下,默认报 warning 错误。开启后,不会报错,而是输出异常信息
set_error_handler('exception_error_handle');

try {
    echo gettype();
} catch (Exception $e) {
    echo $e->getMessage();
}

结果:

gettype() expects exactly 1 parameter, 0 given

本文参与腾讯云自媒体分享计划,欢迎正在阅读的你也加入,一起分享。

发表于

我来说两句

0 条评论
登录 后参与评论

相关文章

来自专栏青枫的专栏

Linux的头文件和C/C++的头文件

=============================================================================

672
来自专栏余林丰

Java IO(2)阻塞式输入输出(BIO)

  在上文中《Java IO(1)基础知识——字节与字符》了解到了什么是字节和字符,主要是为了对Java IO中有关字节流和字符流有一个更好的了解。   本文所...

2065
来自专栏Coding01

看 Laravel 源代码了解 Container

自从上文《看 Laravel 源代码了解 ServiceProvider 的加载》,我们知道 Application (or Container) 充当 Lar...

1395
来自专栏编程一生

PHP开发人员对JAVA的WEB开发入门(初版-基础知识)

1054
来自专栏我的技术专栏

《effective Go》读后记录:GO基础

1394
来自专栏对角另一面

读Zepto源码之Deferred模块

Deferred 模块也不是必备的模块,但是 ajax 模块中,要用到 promise 风格,必需引入 Deferred 模块。Deferred 也用到了上一篇...

2250
来自专栏鸿的学习笔记

Python写的Python解释器(六)

目前可以确认Python虚拟机是一个堆栈机器。它通过指令来控制执行顺序,推入和弹出堆栈的值。在上面的例子中,最后一条指令是RETURN_VALUE,它对应于代码...

451
来自专栏专注 Java 基础分享

初识Hibernate之关联映射(一)

     上篇文章我们对持久化对象进行的学习,了解了它的三种不同的状态并通过它完成对数据库的映射操作。但这都是基于单张表的操作,如果两张或者两张以上的表之间存在...

1778
来自专栏owent

VC和GCC成员函数指针实现的研究(三)

因为是兼容虚继承和非虚继承的,所以赋值的部分的汇编是一样的。这里就不贴了。关键在于执行期它是怎么找到虚基类的。请往下看:

671
来自专栏GreenLeaves

JS模块加载系统设计V1

一、require模块 +function() { var path = location.protocol + "//" + loca...

1845

扫码关注云+社区